
var arrGameFlags = [];



//fix in IE
if (!Object.entries)
        Object.entries = function (obj) {
            var ownProps = Object.keys(obj),
                i = ownProps.length,
                resArray = new Array(i); // preallocate the Array
            while (i--)
                resArray[i] = [ownProps[i], obj[ownProps[i]]];

            return resArray;
        };

$( document ).ready(function() {

	var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

	    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))  // If Internet Explorer, return version number
	    {
	        //alert(parseInt(ua.substring(msie + 5, ua.indexOf(".", msie))));
	        jQuery('body').addClass('isie');
	    }
    else  // If another browser, return 0
	    {
	        //alert('otherbrowser');
	    }



    
    $('.vndatascreen, .credits, .terms').hide();

	//$('#sndbg').prop("volume", 0.5);


	if(getCookie('musicVolume') != ""){
		var defaultMusicVolume = parseFloat(getCookie('musicVolume'));
	} else {
		var defaultMusicVolume = 0.5;
	}


	if ($('body').attr('data-ending') == "true"){
		$('.bottomtext').addClass('hide');

		if(getCookie('musicToggle') != "off"){ 

			setTimeout(function(){
				jQuery('#sndbg').trigger('play');
			}, 3000);

		}


	}


	if(getCookie('seenTutorialNoKeys') != "true"){
		$('.vntitlestart').attr("onclick", "changeStage('how2play')");
	}

	
	jQuery('#sndcursor, #sndenter, #sndfx').prop("volume", defaultMusicVolume);
 	jQuery('#sndbg').prop("volume", defaultMusicVolume / 8);



	  jQuery( "#backgroundMusicSlider" ).slider({
        orientation: "vertical",
        range: "min",
        min: 0,
        max: 1,
        step: 0.05,
        value: defaultMusicVolume,
        slide: function( event, ui ) {
          document.getElementById('sndbg').volume = ui.value;

          setCookie('musicVolume', ui.value, 90);
        

          jQuery('#sndbg').attr('data-volume', document.getElementById('sndbg').volume);


          jQuery('#sndcursor, #sndenter, #sndfx').prop("volume", ui.value);
 	jQuery('#sndbg').prop("volume", ui.value / 8);
     

        }
      });


      if(getCookie('musicToggle') == "off"){   
   
	    jQuery('#sndbg').removeClass('play');
	    jQuery('.backgroundMusicSliderCont i').removeClass('fa-volume-up');
	    jQuery('.backgroundMusicSliderCont i').addClass('fa-volume-off');

      } else {
      	jQuery('#sndbg').trigger('load');
      	jQuery('#sndbg').trigger('play');
      }


	


	readdSoundButton();




	//Start button
	$('.vntitlestart').mousedown(function(){
		$('#sndbg').trigger('load');

		if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
			$('#sndbg').trigger('play');
		}
		


		delete(arrGameFlags);
		console.log('resetting flags: ' +  arrGameFlags);



		$( '.vntitle' ).fadeOut( 1000, function() {
		    $('.vndatascreen').fadeIn(1000);
		    console.log('faded');
		});


	});



	//Check if ending seen

	if ($('.vnending').attr('data-seenending') == "false"){
		$('.vnending').hide();
		$('.vnendingkeystuff').hide();



		setTimeout(function(){
			$('.vnending').fadeIn(1000);
			$('.vnendinglogo').fadeOut(1000);
		}, 7500);

	}


});



function readdSoundButton(){


	$('.buttonselector, .hoverselector, a').mouseover(function(){
		if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
			$('#sndcursor').trigger('load');
			$('#sndcursor').trigger('play');
		}
	});


	$('.buttonselector, .hoverselector, a').mousedown(function(){
		if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
			$('#sndenter').trigger('load');
			$('#sndenter').trigger('play');
		}
	});


}



//Change page in visual novel

function changeStage(stageid){

	//Get stage info


	console.log(stageid);

	
$( ".vndatatextareatext p, .vndatatextareatextoptions button" ).fadeOut( 200);

	

	setTimeout(function(){

		$(window).scrollTop(0);


		//Check if ending

		if ($('#submitending').attr('data-isending') == "true"){


			$('#endingval').val(stageid);


			$('#submitending').submit();




		} else {



				$('.vndatatextareatext').text("");
				$('.vndatatextareatextoptions button').remove();



				arrNewStageData = [];


				var currentLocation =  window.location.toString();
				currentLocation = currentLocation.replace('index.php', '');

				$.getJSON( "stages.json", function( data ) {
				  
				  $.each( data, function( key, val ) {
				    //items.push( "<li id='" + key + "'>" + val + "</li>" );
				   // console.log(key + '-' + val);

				    if (stageid == key){
				    	//Get data for this stage

				    	$.each(val, function( index, value ) {
						 // console.log( index + ": " + value );

						// arrNewStageData.push({index, value });
						arrNewStageData[index] = value;

						});

				    	//console.log(arrNewStageData);



				    	//is Instant Redirect?
				    	var varInstantRedirect = false;
				    	var varRedirectTo = "";
				    	if (arrNewStageData['instantredirect'] == "true"){
			    			varInstantRedirect = true;

			    			if (typeof arrNewStageData['redirectto'] !== 'undefined'){
			    				varRedirectTo = arrNewStageData['redirectto'];

			    			}

				    	}



				    	//Set Flag?
				    	if (arrNewStageData['setflag']){
				    		arrGameFlags[arrNewStageData['setflag']] = true;
				    		console.log('set flag: ' +  arrNewStageData['setflag']);
				    	}







						//Is Flag Required?
				    	if (typeof arrNewStageData['requiresflag'] !== 'undefined'){

				    		console.log('checking for flag:' + arrNewStageData['requiresflag']);

				    		if (arrGameFlags[arrNewStageData['requiresflag']] == true){
				    			varRedirectTo = arrNewStageData['true']['redirectto'];
				    			console.log('flag is true: ' + arrNewStageData['requiresflag']);
				    		} else {
				    			varRedirectTo = arrNewStageData['false']['redirectto'];
				    			console.log('flag is false: ' + arrNewStageData['requiresflag']);
				    		}


				    	}



				    



				    	//Is Random Events thing?

			    		if (arrNewStageData['israndom'] == "true"){
			    			//It's random
			    			console.log('randum');
			    			//Pick random permutation
			    			varPermToPick = Math.floor(Math.random() * 100) + 1; 
			    			console.log(varPermToPick);


			    			numToPick = 100;


			    			 for (var cc=100;cc >= varPermToPick;cc--) {
    

			    			 	if (typeof arrNewStageData[cc] != "undefined") {
								   	numToPick = cc;
								}


							 }

							 arrNewStageData = arrNewStageData[numToPick];
							 console.log(numToPick);


							 if (varInstantRedirect == true){
							 	varRedirectTo = arrNewStageData['redirectto'];
							 }

			    		}



				  



				    	//Is next page ending?

				    	$('#submitending').attr('data-isending', arrNewStageData['isending']);



				    	//stagegraphic

						if (typeof arrNewStageData['graphic'] !== 'undefined') {

						
							varNewGraphic = arrNewStageData['graphic'];


						

							if (varNewGraphic == ""){
								varNewGraphic = "img/stage/blank.gif";
							}

												


						} else {

							varNewGraphic = "img/stage/blank.gif";

						}


						if (varNewGraphic != "img/stage/blank.gif") {

							$('.vndatatextareatext').html('<p><img src="' + varNewGraphic + '" alt="" class="stagegraphic" /></p>')
						}



				    	//dialog text
				    	$('.vndatatextareatext').append(arrNewStageData['textdescription']);



			    		if (typeof arrNewStageData['stagelinks'] !== 'undefined'){

			    			//buttons
					    	arrButtons = Object.entries(arrNewStageData['stagelinks']);
					    	arrButtons.forEach(function (item, index2) {
							

							  $( ".vndatatextareatextoptions" ).append( '<button class="buttonselector" onclick="changeStage(\'' + item[0] + '\');">[' + item[1] + ']</button>' );

							});




					    	readdSoundButton();



			    		}


				    	



						//background music

						if (typeof arrNewStageData['backgroundsound'] !== 'undefined') {

							varCurrentMusic = $('#sndbg').attr('src');
							varNewMusic = arrNewStageData['backgroundsound'];


						

							if (varNewMusic == ""){
								varNewMusic = "snd/blank.mp3";
							}

							if (varCurrentMusic != varNewMusic){
								$('#sndbg').attr('src', varNewMusic);
								$('#sndbg').trigger('load');
								if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
									$('#sndbg').trigger('play');
								}

							}


						}




						//soundeffect

						if (typeof arrNewStageData['soundeffect'] !== 'undefined') {

						
							varNewSound = arrNewStageData['soundeffect'];


						

							if (varNewSound == ""){
								varNewSound = "snd/blank.mp3";
							}

							
								$('#sndfx').attr('src', varNewSound);
								$('#sndfx').trigger('load');
								if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
									$('#sndfx').trigger('play');
								}

							


						}






						//if redirect
						if (varInstantRedirect == true){
							console.log('insta redirect: ' + varRedirectTo)
								
								setTimeout(function(){
									changeStage(varRedirectTo);
								}, 150);

						}



				    }


				    




				  });


			setCookie('seenTutorialNoKeys', 'true', 90);
			$('.bottomtext').addClass('hide');
				
				});






		}



	



	  }, 201);






	

}






function toggleBackgroundMusicSlider(){

  if (jQuery('.backgroundMusicSliderCont i').hasClass('fa-volume-up')){
    // It's playing, pause it


      jQuery('#sndbg').trigger('pause');
    
   
    jQuery('#sndbg').removeClass('play');
    jQuery('.backgroundMusicSliderCont i').removeClass('fa-volume-up');
    jQuery('.backgroundMusicSliderCont i').addClass('fa-volume-off');
    setCookie('musicToggle', 'off', 90);


  } else {
    // It's not playing, play it

    
    
      jQuery('#sndbg').trigger('play');
    

    jQuery('#sndbg').addClass('play');
    jQuery('.backgroundMusicSliderCont i').addClass('fa-volume-up');
    jQuery('.backgroundMusicSliderCont i').removeClass('fa-volume-off');
    setCookie('musicToggle', 'on', 90);


  }
}



function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires;
} 

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
    }
    return "";
} 




function confirmPlayAgain(){

	var ifConfirm = confirm('You will need to play the game again to obtain this Key if you do not login and click "Claim Key".\r\n\r\nClick OK if you are sure you want to play again.');


	return ifConfirm
}


function showTerms(){
	$('.terms').fadeIn();
}

function hideTerms(){
	$('.terms').fadeOut();
}

function showCredits(){
	$('.credits').fadeIn();
}

function hideCredits(){
	$('.credits').fadeOut();
}


function showKeyStuff(){

	$('.vnendingtext').fadeOut(1000);

	setTimeout(function(){
		$('.vnendingkeystuff').fadeIn(1000);
	}, 1001);


}


function toggleEndingText(){

	if ($('.vnending').is(":hidden")){
		$('.vnending').fadeIn(500);
	} else {
		$('.vnending').fadeOut(500);
	}


}